Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 831021 - dev-util/nvidia-cuda-sdk-11.5.1 fails to compile: std_function.h:435:145: error: parameter packs not expanded with ...:
Summary: dev-util/nvidia-cuda-sdk-11.5.1 fails to compile: std_function.h:435:145: err...
Status: RESOLVED OBSOLETE
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Gentoo Science Related Packages
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2022-01-11 15:29 UTC by Agostino Sarubbo
Modified: 2022-03-25 20:33 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log.xz (build.log.xz,195.88 KB, application/x-xz)
2022-01-11 15:29 UTC, Agostino Sarubbo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2022-01-11 15:29:09 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: dev-util/nvidia-cuda-sdk-11.5.1 fails to compile.
Discovered on: amd64 (internal ref: ci)

NOTE:
If you think this is a GCC-11 related issue, please block bug 732706.
Comment 1 Agostino Sarubbo gentoo-dev 2022-01-11 15:29:12 UTC
Created attachment 761908 [details]
build.log.xz

build log and emerge --info (compressed because it exceeds attachment limit, use 'xzless' to read it)
Comment 2 Agostino Sarubbo gentoo-dev 2022-01-11 15:29:13 UTC
Error(s) that match a know pattern in addition to what has been reported in the summary:


Package 'glfw3', required by 'virtual:world', not found
/usr/lib/gcc/x86_64-pc-linux-gnu/11.2.1/include/g++-v11/bits/std_function.h:435:145: error: parameter packs not expanded with ‘...’:
Comment 3 Jérôme Borme 2022-01-28 23:00:36 UTC
The same problem affects sci-chemistry/gromacs: usr/lib/gcc/x86_64-pc-linux-gnu/11.2.1/include/g++-v11/bits/std_function.h:530:146: error: parameter packs not expanded with ‘...’:

I rebuilt sci-chemistry/gromacs (-2021.4, -2021.5, -2022_rc1) and its dependency dev-util/nvidia-cuda-toolkit (not -sdk) with gcc-10.3.0-r2 and gcc-11.2.1_p20220115 with same result, gromacs fails to build.
Comment 4 Guilherme Amadio gentoo-dev 2022-01-31 11:35:49 UTC
I've hit this too, it's just a GCC that is too new for CUDA. I've worked around this by compiling with C++14 rather than C++17, or by using an older version of GCC. The next CUDA release should have this fixed.
Comment 5 Red 2022-03-22 22:34:57 UTC
Even when adding -std=c++14 to CXXFLAGS it still won't compile with the same errors given.
Using GCC 11.2.1.
Comment 6 Guilherme Amadio gentoo-dev 2022-03-23 10:32:21 UTC
Please switch to the latest CUDA (11.6.1) if you can. This is an upstream bug that has been fixed in the newer versions.
Comment 7 Red 2022-03-24 19:46:51 UTC
This isn't resolved, Gentoo's nvidia-cuda-sdk version is still 11.5.1
Comment 8 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-03-24 19:50:47 UTC
(In reply to Red from comment #7)
> This isn't resolved, Gentoo's nvidia-cuda-sdk version is still 11.5.1

Use the toolkit instead?
Comment 9 Red 2022-03-25 20:33:49 UTC
(In reply to Sam James from comment #8)
> (In reply to Red from comment #7)
> > This isn't resolved, Gentoo's nvidia-cuda-sdk version is still 11.5.1
> 
> Use the toolkit instead?

Are they the same thing? I was only installing nvidia-cuda-sdk because it was an optional dependency of another package (I forget which).